-#!/bin/sh
+#!/bin/zsh
#
# func/vcsh
#
# Copyright © 1994–2008 martin f. krafft <madduck@madduck.net>
# Released under the terms of the Artistic Licence 2.0
#
-# Source repository: http://git.madduck.net/v/etc/zsh.git
+# Source repository: git://git.madduck.net/etc/zsh.git
#
local FGIT_BASE="$HOME/.fgits"
-if [ "${1:---help}" = '--help' ] || [ $# -gt 1 ]; then
- echo "usage: ${0##*/} reponame" >&2
- echo "usage: ${0##*/} -l" >&2
- [ "$1" = '--help' ]
- return $?
-
-elif [ "$1" = '-l' ]; then
- for i in $FGIT_BASE/*.git; do
- i="${i#$FGIT_BASE/}"
- echo "${i%.git}"
- done
- return 0
+if [[ "$1" == '-l' ]]
+then
+ for i in $FGIT_BASE/*.git
+ do
+ i="${i#$FGIT_BASE/}"
+ echo "${i%.git}"
+ done
+ return 0
+elif [[ "$1" == '-c' ]]
+then
+ shift
+
+ if [[ -z "$1" ]]
+ then
+ echo "E: no repository name given" >&2
+ return 2
+ fi
+ if [[ -e "$FGIT_BASE/${1}.git" ]]
+ then
+ echo "E: repository '$1' still exists" >&2
+ return 2
+ fi
+
+ git init --bare "$FGIT_BASE/${1}.git"
+ cd "$FGIT_BASE/${1}.git"
+ git config core.bare false
+ git config core.worktree ../../
+ git config core.excludesfile "$FGIT_BASE/${1}.ignore"
+ cd -
+
+ [[ -e "$FGIT_BASE/${1}.ignore" ]] || echo "/*" > "$FGIT_BASE/${1}.ignore"
+fi
+if [[ "${1:---help}" == '--help' ]] || [[ $# -gt 1 ]]
+then
+ echo "usage: ${0##*/} reponame" >&2
+ echo "usage: ${0##*/} -l" >&2
+ echo "usage: ${0##*/} -c reponame" >&2
+ [ "$1" = '--help' ]
+ return $?
fi
if [ ! -d "$FGIT_BASE/${1}.git" ]; then